#include <bits/stdc++.h>
using namespace std;


template <typename T> T mod_inv_in_range(T a, T m) {
	// assert(0 <= a && a < m);
	T x = a, y = m;
	// coeff of a in x and y
	T vx = 1, vy = 0;
	while (x) {
		T k = y / x;
		y %= x;
		vy -= k * vx;
		std::swap(x, y);
		std::swap(vx, vy);
	}
	assert(y == 1);
	return vy < 0 ? m + vy : vy;
}

template <typename T> struct extended_gcd_result {
	T gcd;
	T coeff_a, coeff_b;
};
template <typename T> extended_gcd_result<T> extended_gcd(T a, T b) {
	T x = a, y = b;
	// coeff of a and b in x and y
	T ax = 1, ay = 0;
	T bx = 0, by = 1;
	while (x) {
		T k = y / x;
		y %= x;
		ay -= k * ax;
		by -= k * bx;
		std::swap(x, y);
		std::swap(ax, ay);
		std::swap(bx, by);
	}
	return {y, ay, by};
}

template <typename T> T mod_inv(T a, T m) {
	a %= m;
	a = a < 0 ? a + m : a;
	return mod_inv_in_range(a, m);
}

template <int MOD_> struct modnum {
	static constexpr int MOD = MOD_;
	static_assert(MOD_ > 0, "MOD must be positive");

private:
	int v;

public:

	modnum() : v(0) {}
	modnum(int64_t v_) : v(int(v_ % MOD)) { if (v < 0) v += MOD; }
	explicit operator int() const { return v; }
	friend std::ostream& operator << (std::ostream& out, const modnum& n) { return out << int(n); }
	friend std::istream& operator >> (std::istream& in, modnum& n) { int64_t v_; in >> v_; n = modnum(v_); return in; }

	friend bool operator == (const modnum& a, const modnum& b) { return a.v == b.v; }
	friend bool operator != (const modnum& a, const modnum& b) { return a.v != b.v; }

	modnum inv() const {
		modnum res;
		res.v = mod_inv_in_range(v, MOD);
		return res;
	}
	friend modnum inv(const modnum& m) { return m.inv(); }
	modnum neg() const {
		modnum res;
		res.v = v ? MOD-v : 0;
		return res;
	}
	friend modnum neg(const modnum& m) { return m.neg(); }

	modnum operator- () const {
		return neg();
	}
	modnum operator+ () const {
		return modnum(*this);
	}

	modnum& operator ++ () {
		v ++;
		if (v == MOD) v = 0;
		return *this;
	}
	modnum& operator -- () {
		if (v == 0) v = MOD;
		v --;
		return *this;
	}
	modnum& operator += (const modnum& o) {
		v -= MOD-o.v;
		v = (v < 0) ? v + MOD : v;
		return *this;
	}
	modnum& operator -= (const modnum& o) {
		v -= o.v;
		v = (v < 0) ? v + MOD : v;
		return *this;
	}
	modnum& operator *= (const modnum& o) {
		v = int(int64_t(v) * int64_t(o.v) % MOD);
		return *this;
	}
	modnum& operator /= (const modnum& o) {
		return *this *= o.inv();
	}

	friend modnum operator ++ (modnum& a, int) { modnum r = a; ++a; return r; }
	friend modnum operator -- (modnum& a, int) { modnum r = a; --a; return r; }
	friend modnum operator + (const modnum& a, const modnum& b) { return modnum(a) += b; }
	friend modnum operator - (const modnum& a, const modnum& b) { return modnum(a) -= b; }
	friend modnum operator * (const modnum& a, const modnum& b) { return modnum(a) *= b; }
	friend modnum operator / (const modnum& a, const modnum& b) { return modnum(a) /= b; }
};

template <typename T> T pow(T a, long long b) {
	assert(b >= 0);
	T r = 1; while (b) { if (b & 1) r *= a; b >>= 1; a *= a; } return r;
}

using num = modnum<998244353>;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N, M, L;
	cin >> N >> M >> L;

	string S;
	cin >> S;
	int l_mask = 0;
	for(int i = 0; i < L; i++){
		if(S[i] == '1') l_mask ^= (1 << (L-1-i));
	}
	vector<vector<num> > ways;
	int X = max(N, M);

	int B = (1 << (L+1));
	vector<vector<vector<num> > > dp(2, vector<vector<num> >(1 << L, vector<num>(1 << B, 0)));
	dp[0][0][0] += 1;
	for(int l = 0; l < X; l++){
		vector<vector<vector<num> > > ndp(2, vector<vector<num> >(1 << L, vector<num>(1 << B, 0)));
		for(int b = 0; b < 2; b++){
			for(int cur = 0; cur < (1 << L); cur++){
				for(int seen = 0; seen < (1 << B); seen++){
					if(dp[b][cur][seen] == 0) continue;
					for(int nxt : {0, 1}){
						int ncur = (cur << 1) ^ nxt;
						int nb = b;
						int nseen = seen;
						if(l >= L){
							nseen |= (1 << ncur);
						}
						ncur &= (1 << L) - 1;
						if(l >= L-1 && ncur == l_mask){
							nb = 1;
						}
						ndp[nb][ncur][nseen] += dp[b][cur][seen];
					}
				}
			}
		}
		dp = ndp;
		for(int x : {N, M}){
			if(x == l+1){
				vector<num> freq(1 << B);
				for(int cur = 0; cur < (1 << L); cur++){
					for(int seen = 0; seen < (1 << B); seen++){
						freq[seen] += dp[1][cur][seen];
					}
				}
				ways.push_back(freq);
			}
		}
	}
	assert(ways.size() == 2);
	vector<num> ways_subset = ways[0];
	for(int i = 0; i < B; i++){
		for(int j = 0; j < (1 << B); j++){
			if(j & (1 << i)) continue;
			ways_subset[j ^ (1 << i)] += ways_subset[j];
		}
	}
	num ans = 0;
	for(int i = 0; i < (1 << B); i++){
		ans += ways[1][i] * ways_subset[(1 << B) - 1 - i];
	}
	cout << ans << '\n';
}
